#version 450

layout (location = 0) in vec3 inPosition;
layout (location = 0) out vec4 outColor;

layout (binding = 0) uniform XYZS {
  vec4 posSize[16000];
} poss;

layout (binding = 1) uniform Color {
  vec4 inColor[16000];
} col;

layout(binding = 2) uniform CameraBuffer
{
	vec4 camPos;
	mat4 viewTransform;
  mat4 worldTransform;
}ubo;

out gl_PerVertex
{
	vec4 gl_Position;
	float gl_PointSize;
};

void main ()
{
  vec4 pos = poss.posSize[gl_InstanceIndex];
  float particleSize = pos.w;
	vec3 particleCenter_wordspace = pos.xyz;

	vec3 vertexPosition_worldspace =
		particleCenter_wordspace + inPosition * particleSize;

  mat4 transform = ubo.viewTransform * ubo.worldTransform;
  outColor = col.inColor[gl_InstanceIndex];
  gl_Position = transform * vec4(vertexPosition_worldspace, 1.0f);
  gl_PointSize = pos.w;
}
